<?php
namespace Andre\WebtreesAddOn\PlaceDoc;
/* =================================
*   class sosaClass V-1-0 for module sosa V-2-7-1 for WT 1.7.1 and +
*   André DUMAS http://www.adumas.1s.fr/wt
*   July 2015
*	-------------------------------
*	 André DUMAS FRANCE JUL 2017
*---------------------------------
*	Version 1-0-1  to update  my modules
*	TODO >>>>This file will be put in app/Functions/myFunctions.php
*	to be used with each of my modules 
*	to search a new version
 ******************************************
 *  =.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=
 *  =	André DUMAS FRANCE				  =
 *  = http://www.adumas.1s.fr/wt/		  =
 *  =  http://www.adumas.1s.fr/download/  =
 *  = contact: a.dumas1  at  free.fr	  =
 *  =.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=
*/

use Fisharebest\Webtrees\Database;
use Fisharebest\Webtrees\Filter;
use Fisharebest\Webtrees\Functions\Functions;
use Fisharebest\Webtrees\Tree;
use Fisharebest\Webtrees\File;
use Fisharebest\Webtrees\I18N;
use Fisharebest\Webtrees\Auth;
use Fisharebest\Webtrees\Individual;
use Fisharebest\Webtrees\Module;
use Fisharebest\Webtrees\Site;


use PDO;

class myUpdateFunctions {
	
	const CUSTOM_VERSION = '1-0-3';
	const CUSTOM_VERSION_DATE = '09-12-2017';

	CONST MY_BASE_URL_2 = 'http://www.adumas.1s.fr/wt/' ;
	CONST UPDATE_INTERVAL = 604800; //7 days
	/*-
	*   In each module admin page
	*/
	public static function lookForNewVersion($module_name, $custom_version, $new_version){
		$update = null;
		
		if (!null == $new_version){
			//true/false
			$update = self::compareVersions($new_version, $custom_version);
		}
		if ($update){
			return self::getNewVersionLink($module_name, $new_version);
		} else {
			return false;
		}
	}

	/*-
	*/	
	public static function checkNewVersion($module_name, $custom_version){
		$update = null;
		
		$new_version = self::getVersionAvailable($module_name);
		if (!null == $new_version){
			//true/false
			$update = self::compareVersions($new_version, $custom_version);
		}
		if ($update){
			return self::getNewVersionLink($module_name, $new_version);
		} else {
			return false;
		}
	}
	
	/*-
	*	read dir /versions to know myModules
	* 	that means a catalogue of my mdules
	*	used in deskTab 
	*		for admins 
	*		return myModules[]
	*/	
	public static function getMyModules(){
		$url_versions = Site::getPreference('MY_VERSIONS_BASE_URL');
		$modules = array();
		$str = File::fetchUrl($url_versions . 'myModules-1.txt');
		
		if (!null == $str){
			$mods = explode(';', $str ) ;
			foreach ($mods as $mod){
				$tmp = explode(',', $mod);
				$modules[trim($tmp[0])] = array('name'=>trim($tmp[0]), 'version'=>trim($tmp[1]), 'date'=>trim($tmp[2]), 'needUpdate'=>false);
				//$allMods .= trim($tmp[0]) . ' ';
			}
			Site::setPreference('LATEST_MY_MODS_VERSION', serialize($modules));
			//last checking = more than 7 days
			Site::setPreference('LATEST_MY_MODS_CHECKING_TIMESTAMP', WT_TIMESTAMP);
			return $modules;
		} else {
			//no connection		
			if (!null == ($tmp = unserialize(Site::getPreference('LATEST_MY_MODS_VERSION')))){
				return $tmp;
			} else {
				return null;
			}
			
		}
	}
	
	/*-
	*/
	public static function checkNewModsVersions($now = false){
		$MyMods = '';
		$last_checking_timestamp = Site::getPreference('LATEST_MY_MODS_CHECK_TIMESTAMP');

		if (($last_checking_timestamp < WT_TIMESTAMP - self::UPDATE_INTERVAL) || ($last_checking_timestamp === null)  || ($now) ) {	
			//last checking = more than 7 days
			Site::setPreference('LATEST_MY_MODS_CHECK_TIMESTAMP', WT_TIMESTAMP);
			$allMyMods = self::getMyModules();
		}	
	}
	
	/*-
	*  myModules active?
	*  return MyModulesActive['mod_name']
	*/	
	public static function getMyModulesActive($mMods){
		$MyModulesActive = array();
		foreach ($mMods as $mMod){
			if (Module::getModuleByName($mMod) !== null ){
				$MyModulesActive[] =  $mMod; 
			}
		}
	return $MyModulesActive;	
	}
	
	/*-
	*	get version of the active modules
	*	return these_version[module_name] = this_mversion
	*/
	public static function getCurrentVersions(array $myModules ){
		$these_version = array();
		foreach ($myModules as $mod_name => $version){
			if (Module::getModuleByName($mod_name) !== null ){
			$these_version[$mod_name] = 
													Database::prepare("
													SELECT SQL_CACHE setting_value FROM  `##module_setting` WHERE module_name =:name 
													AND setting_name = 'CUSTOM_VERSION'  
													ORDER BY module_name
													")->execute(array(
																	'name' => $mod_name))->fetchOne();
			} else {
				$these_version[$mod_name] = null;
			}														
		}
	return $these_version;	
	}
	
	/*-
	*  versions with this format:
	*		1-7-9-2 1.7.9.2 1.7.-9.2 ...
	*		1-7-9-2b
	*		4-7-9-2-1
	*		you can mixe - and .
	*	return $update = true/false
	*/
	
	public static function compareVersions($new_version, $this_version){
		$pattern = '/[a-zA-Z]$/';
					
		$nv = preg_split('/[-.]/' , $new_version);
		$tv = preg_split('/[-.]/' , $this_version);
		$dl = count($nv) - count($tv);
		//$dl = 0 compare simple  suffixe ou non-> dernier terme
		//$dl > 0  compare simple sur long de tv
		//dl < 0   update ou erreur
		if ( $dl == 0 ){
			for ($i = 0; $i < count($nv) - 2; $i++){
				if ($nv[$i] > $tv[$i] ){
					//update
					return $update = true;
				}
			}
			//dernier terme
			//post-fixe  sur le dernier terme 2a 3b...??
			$pnv = preg_match($pattern, $nv[count($nv) - 1], $nvmatches);
			$ptv = preg_match($pattern, $tv[count($tv) - 1], $tvmatches);
			
			$nsuf = substr($nv[count($nv) - 1], -1);
			$tsuf = substr($tv[count($tv) - 1], -1);
			
			if ( ( $pnv ) && ($ptv  ) ){
				//isoler n° version
					$nnv = substr($nv[count($nv) - 1],0,  -1);
					$ntv = substr($tv[count($tv) - 1],0,  -1);
						if (($nnv > $ntv) || ( (($nnv == $ntv)  && ( $nvmatches[0] > $tvmatches[0] )) )  ){
							//update
							return $update = true;
						} 
			} elseif ((!$pnv && $ptv ) && ($nv[count($nv) - 1] > substr($tv[count($tv) - 1],0,  -1)  )  ){
				//update
				return $update = true;
			
			} elseif (($pnv && !$ptv ) && (substr($nv[count($nv) - 1],0,  -1) == $tv[count($tv) - 1]   )  ){
				//update
				return $update = true;
			} else {
				if ( $nv[count($nv) - 1] > $tv[count($tv) - 1] ){
					return true;
				}
			}
		} elseif ($dl < 0){
			for ($i = 0; $i < count($nv) - 1; $i++){
				if ($nv[$i] > $tv[$i] ){
					//update
					return $update = true;
				} 
			}	
		} else {
			//update
			return $update = true;
		}
	return $update = false;	
	}

	/*-
	*	link to download new version
	*
	*/
	
	public static function getNewVersionLink($module_name, $version){
		
		$link = Site::getPreference('MY_BASE_URL') . 'download';
		return 
				'<a href="' . $link . '"><button>' .
					I18N::translate('Click to open page and download the new version') .
				'</button></a>';
	}

	
	public static function AuthId(){
		if (Auth::id() === null){
			$user_id = 0;
		} else {
			$user_id = Auth::id();
		}
	return $user_id;	
	}
	

	
}